package net.alviano.safe;

import static org.apache.commons.lang3.Validate.*;

public final class Automobile extends Veicolo {
	public Automobile(Id id, Targa targa, CasaProduttrice casaProduttrice, ModelloVeicolo modello, Prezzo prezzo) {
		super(notNull(id), notNull(targa), notNull(casaProduttrice), notNull(modello), notNull(prezzo));
	}
	
	@Override
	public Prezzo calcolaPrezzoFinale() {
		if(prezzo().compareTo(new Prezzo(10000)) < 0) return prezzo().scontato(new AliquotaSconto(50));
		if(prezzo().compareTo(new Prezzo(20000)) < 0) return prezzo().scontato(new AliquotaSconto(100));
		return prezzo();
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null) return false;
		if(o.getClass() != Automobile.class) return false;
		Automobile t = (Automobile) o;
		return this.id().equals(t.id());
	}
	
	@Override
	public int hashCode() {
		int res = 17;
		res = 31 * res + this.id().hashCode();
		res = 31 * res + this.targa().hashCode();
		res = 31 * res + this.casaProduttrice().hashCode();
		res = 31 * res + this.modello().hashCode();
		res = 31 * res + this.prezzo().hashCode();
		return res;
	}
}
