package net.alviano.safe;

import static org.apache.commons.lang3.Validate.*;

public final class ModelloVeicolo implements Comparable<ModelloVeicolo> {
	private final String value;
	
	public ModelloVeicolo(String value) {
		this.value = notBlank(value);
		inclusiveBetween(1, 100, value.length());
		matchesPattern(value, "[0-9A-Za-z -]*");
		// altra validazione
	}
	
	public String value() {
		return this.value;
	}
	
	@Override
	public String toString() {
		return value;
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null) return false;
		if(o.getClass() != ModelloVeicolo.class) return false;
		ModelloVeicolo n = (ModelloVeicolo) o;
		return this.value.equals(n.value);
	}
	
	@Override
	public int hashCode() {
		return this.value.hashCode();
	}

	@Override
	public int compareTo(ModelloVeicolo other) {
		return value.compareTo(other.value);
	}
	
}
