package net.alviano.safe;

import static org.apache.commons.lang3.Validate.*;

public final class Moto extends Veicolo {
	public Moto(Id id, Targa targa, CasaProduttrice casaProduttrice, ModelloVeicolo modello, Prezzo prezzo) {
		super(notNull(id), notNull(targa), notNull(casaProduttrice), notNull(modello), notNull(prezzo));
	}
	
	@Override
	public Prezzo calcolaPrezzoFinale() {
		if(prezzo().compareTo(new Prezzo(7000)) < 0) return prezzo().scontato(new AliquotaSconto(30));
		if(prezzo().compareTo(new Prezzo(15000)) < 0) return prezzo().scontato(new AliquotaSconto(75));
		return prezzo();
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null) return false;
		if(o.getClass() != Moto.class) return false;
		Moto t = (Moto) o;
		return this.id().equals(t.id());
	}
	
	@Override
	public int hashCode() {
		int res = 19;
		res = 31 * res + this.id().hashCode();
		res = 31 * res + this.targa().hashCode();
		res = 31 * res + this.casaProduttrice().hashCode();
		res = 31 * res + this.modello().hashCode();
		res = 31 * res + this.prezzo().hashCode();
		return res;
	}
}
